searchNodes=[{"doc":"","ref":"PowSessionToolkit.html","title":"PowSessionToolkit","type":"module"},{"doc":"","ref":"PowSessionToolkit.AbsintheIntegration.html","title":"PowSessionToolkit.AbsintheIntegration","type":"module"},{"doc":"","ref":"PowSessionToolkit.Config.html","title":"PowSessionToolkit.Config","type":"module"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_opts/1","title":"PowSessionToolkit.Config.access_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_salt/1","title":"PowSessionToolkit.Config.access_salt/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_sig_cookie_name/1","title":"PowSessionToolkit.Config.access_sig_cookie_name/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_sig_cookie_opts/1","title":"PowSessionToolkit.Config.access_sig_cookie_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_ttl/1","title":"PowSessionToolkit.Config.access_ttl/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#access_verify_opts/1","title":"PowSessionToolkit.Config.access_verify_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_opts/1","title":"PowSessionToolkit.Config.refresh_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_salt/1","title":"PowSessionToolkit.Config.refresh_salt/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_sig_cookie_name/1","title":"PowSessionToolkit.Config.refresh_sig_cookie_name/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_sig_cookie_opts/1","title":"PowSessionToolkit.Config.refresh_sig_cookie_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_ttl/1","title":"PowSessionToolkit.Config.refresh_ttl/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#refresh_verify_opts/1","title":"PowSessionToolkit.Config.refresh_verify_opts/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Config.html#session_store/1","title":"PowSessionToolkit.Config.session_store/1","type":"function"},{"doc":"Constants used throughout the PowSessionToolkit modules. When used, this module sets several constants as module attributes. The following attributes are set: @private_session_key @private_access_token_payload_key @private_access_token_key @private_access_token_expiration_key @private_refresh_token_payload_key @private_refresh_token_key @private_refresh_token_expiration_key @private_auth_error_key @private_token_signature_transport_key @private_session_ttl_key Example defmodule MyModule do use Elixir.PowSessionToolkit.Constants def my_function(), do: @private_session_key end","ref":"PowSessionToolkit.Constants.html","title":"PowSessionToolkit.Constants","type":"module"},{"doc":"A session as stored in Mnesia by PowSessionToolkit.MnesiaSessionStore.","ref":"PowSessionToolkit.Session.html","title":"PowSessionToolkit.Session","type":"module"},{"doc":"Gets a %Elixir.PowSessionToolkit.Session{} from a conn&#39;s private map.","ref":"PowSessionToolkit.Session.html#get_from_conn/1","title":"PowSessionToolkit.Session.get_from_conn/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Session.html#t:t/0","title":"PowSessionToolkit.Session.t/0","type":"type"},{"doc":"Pow session manager implementation. This implementation attempts to achieve: parity with the security provided by session cookies in browsers, which means it should not be possible to steal a valid auth token from JavaScript code not being limited to the 4kB limit for cookies in browsers short lived stateless access tokens separate from long-lived refresh tokens ability to revoke other sessions in the form of revoking refresh tokens so that token renewal is not possible native clients do not need to handle cookies but can use simple bearer tokens for access / refresh Token handling This implementation uses asymmetric Phoenix tokens (refresh and access), where the refresh token is tracked using session_store(config) so that sessions can be forcibly logged out and so that refresh tokens are single-use only. Access tokens are stateless and are not tracked server-side. All tokens are passed using the &quot;authorization&quot; header. However, the signatures needed to verify the integrity of the tokens is either transported to the client as part of the token itself (token format &quot;header.payload.signature&quot;) or separately as a cookie (in which case the token format will be &quot;header.payload&quot;). This behaviour is set for the lifetime of the session when the session is created, by specifying :bearer or :cookie as conn.private[:pow_session_toolkit_token_signature_transport] and is enforced when a token is verified. This means that the signature of a refresh token of a session with transport mechanism &quot;bearer&quot; MUST be passed to refresh/2 as part of the bearer token, and will be rejected when passed using a cookie, and vice-versa. For native apps or other clients that have a secure way of storing tokens, &quot;bearer&quot; is recommended. For browser clients, it is recommended to use the &quot;cookie&quot; signature transport mechanism, which will prevent the client from having to use an insecure storage mechanism like LocalStorage for token signatures. The rest of the token, however, can simply be held in memory or stored in whatever way the client fancies. In case of a successful XSS breach of the web application only the token payloads will be exposed. Those payloads cannot be used as authentication tokens because they have no validity without their signature components, which cannot be accessed from JavaScript. The signature is a HMAC, which cannot be generated without the server-side secret key, and the payload cannot be altered without invalidating the signature. Splitting the token signature from the header and payload also means that tokens can (really shouldn&#39;t, but can) grow larger than the 4kB limit for a cookie without problems, because only the signature is held in a cookie and not the payload. Note that this does not mean that all security issues have been solved. It is still possible to use XSS attacks to make API requests with a valid auth header while the XSS code has access to the browser context in which the tokens live, because the signature cookie is sent automatically by the browser. Cross-site request forgery Cross-site request forgery issues are left for controllers to deal with when applicable. As per OWASP guidelines, setting a custom header is sufficient to protect against CSRF for an API. Since the &quot;authorization&quot; header with a bearer token qualifies, such issues (apart from login-CSRF!) should not arrise when using this implentation to secure an API, but can and will arise when using this implementation to secure Phoenix HTML applications. So use Plug.CSRFProtection in that case. Config values The following values must be set in the config (or in the application environment under the matching otp_app) (example or - in case of optionals - default values): pow_session_toolkit: [ access_token_ttl: 30 * 60, refresh_token_ttl: 2 * 30 * 24 * 60 * 60, refresh_signature_cookie_name: &quot;_pow_session_toolkit_refresh_signature&quot;, access_signature_cookie_name: &quot;_pow_session_toolkit_access_signature&quot;, refresh_path: &quot;/api/v1/current_session/refresh&quot;, session_store: MyMnesiaCacheModule, # optional (defaults shown first) session_ttl: nil || 365 * 24 * 60 * 60, access_token_salt: &quot;access_token&quot;, refresh_token_salt: &quot;refresh_token&quot;, refresh_token_key_digest: :sha512 || :sha256 || :sha384, access_token_key_digest: :sha256 || :sha384 || :sha512 ] The *_ttl values are in seconds, except for session_ttl which can also be nil. The salts are not cryptographic salts but behave like token namespaces, separating refresh and access tokens. Maximum session age A session can optionally have an absolute maximum age, which is set when the session is first created and is not affected by refreshes. It is calculated as session_ttl + session creation timestamp. By default, no maximum age is set (it defaults to nil). The maximum age can be set globally in the config, as shown above. It can also, however, be set using conn.private[:pow_session_toolkit_session_ttl], permitting advanced handling by controllers. This makes it possible to have a different session max age for users with different credential levels, session types, access levels etc etc. Note that the value of conn.private[:pow_session_toolkit_session_ttl] overrides the global config value.","ref":"PowSessionToolkit.SessionPlugs.html","title":"PowSessionToolkit.SessionPlugs","type":"module"},{"doc":"Configures the connection for Pow, and fetches user. :plug is appended to the passed configuration, so the current plug will be used in any subsequent calls to create, update and delete user credentials from the connection. The configuration is then set for the conn with Pow.Plug.put_config/2. If a user can&#39;t be fetched with Pow.Plug.current_user/2, do_fetch/2 will be called.","ref":"PowSessionToolkit.SessionPlugs.html#call/2","title":"PowSessionToolkit.SessionPlugs.call/2","type":"function"},{"doc":"Create or update a session. If conn.private.pow_session_toolkit_session exists, the session is updated, otherwise a new one is created. These values are set by refresh/2 when appropriate. In both cases, new access / refresh tokens are created and stored in the conn&#39;s private map. The server-side session stored in session_store(config) is created / updated as well. The tokens&#39; signatures are split off and sent as cookies if the session&#39;s token signature transport mechanism is set to :cookie. The session can optionally have a maximum age set when it is created. For access token signatures, a cookie named &quot;access_sig_cookie_name&quot; is sent with the following options: [http_only: true, extra: &quot;SameSite=Strict&quot;, secure: true]. For refresh token signatures, a cookie named &quot;refresh_sig_cookie_name&quot; is sent with the following options: [http_only: true, extra: &quot;SameSite=Strict&quot;, secure: true].","ref":"PowSessionToolkit.SessionPlugs.html#create/3","title":"PowSessionToolkit.SessionPlugs.create/3","type":"function"},{"doc":"Delete the persistent session identified by the session_id in the access token payload. Note that the access token remains valid until it expires, it is left up to the client to drop the access token. It will no longer be possible to refresh the session, however.","ref":"PowSessionToolkit.SessionPlugs.html#delete/2","title":"PowSessionToolkit.SessionPlugs.delete/2","type":"function"},{"doc":"Calls create/3 and assigns the current user. The user is assigned to the conn with Pow.Plug.assign_current_user/3.","ref":"PowSessionToolkit.SessionPlugs.html#do_create/3","title":"PowSessionToolkit.SessionPlugs.do_create/3","type":"function"},{"doc":"Calls delete/2 and removes the current user assigned to the conn. The user assigned is removed from the conn with Pow.Plug.assign_current_user/3.","ref":"PowSessionToolkit.SessionPlugs.html#do_delete/2","title":"PowSessionToolkit.SessionPlugs.do_delete/2","type":"function"},{"doc":"Calls fetch/2 and assigns the current user to the conn. The user is assigned to the conn with Pow.Plug.assign_current_user/3.","ref":"PowSessionToolkit.SessionPlugs.html#do_fetch/2","title":"PowSessionToolkit.SessionPlugs.do_fetch/2","type":"function"},{"doc":"Fetch the session state from the access token in the &quot;authorization&quot; header. The token must not be older than access_ttl seconds and correctly signed. The signature must originate from the correct signature transport channel. The token payload is put in conn.private.pow_session_toolkit_access_token_payload and the user is assigned to conn.assigns.current_user. The user is NOT fetched from the database, it is left for controllers to decide if this is needed.","ref":"PowSessionToolkit.SessionPlugs.html#fetch/2","title":"PowSessionToolkit.SessionPlugs.fetch/2","type":"function"},{"doc":"Create new access / refresh tokens if a valid refresh token is found. The token is read from the authorization header, and the token&#39;s signature either from the header or from cookie &quot;@refresh_sig_cookie_name&quot;. The token signature source (bearer or cookie) must match the token_signature_transport specified in the token payload. A refresh token can only be used to refresh a session once. A single refresh token id is stored in the server-side session by create/2 to enforce this.","ref":"PowSessionToolkit.SessionPlugs.html#refresh/2","title":"PowSessionToolkit.SessionPlugs.refresh/2","type":"function"},{"doc":"Tokens to be communicated to the client.","ref":"PowSessionToolkit.Tokens.html","title":"PowSessionToolkit.Tokens","type":"module"},{"doc":"Creates a new %Elixir.PowSessionToolkit.Tokens{} from the values in a conn&#39;s private map.","ref":"PowSessionToolkit.Tokens.html#new/1","title":"PowSessionToolkit.Tokens.new/1","type":"function"},{"doc":"","ref":"PowSessionToolkit.Tokens.html#t:t/0","title":"PowSessionToolkit.Tokens.t/0","type":"type"},{"doc":"PowSessionToolkit TODO: Add description","ref":"readme.html","title":"PowSessionToolkit","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding pow_session_toolkit to your list of dependencies in mix.exs: def deps do [ {:pow_session_toolkit, &quot;~&gt; 0.1.5&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/pow_session_toolkit.","ref":"readme.html#installation","title":"PowSessionToolkit - Installation","type":"extras"},{"doc":"Configuration Configure pow itself as usual, for example: config :my_otp_app, :pow, user: MyApp.DB.User, repo: MyApp.Repo, users_context: MyApp.DB.Users, cache_store_backend: Pow.Store.Backend.MnesiaCache Add a key to the standard pow config called :pow_session_toolkit and add the configuration values as specified in session_plugs.ex there: config :my_otp_app, :pow, user: MyApp.DB.User, repo: MyApp.Repo, users_context: MyApp.DB.Users, cache_store_backend: Pow.Store.Backend.MnesiaCache, pow_session_toolkit: [ access_token_ttl: 3600 ]","ref":"readme.html#guide","title":"PowSessionToolkit - Guide","type":"extras"}]